package de.unisaar.jfap.ex6.operator;

/**
 * Unary minus operator.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public class UnaryMinus extends UnaryOperator {

  public UnaryMinus(Operator arg) {
    super(arg);
  }

  @Override
  public double evaluate() {
    return -1 * super.arg.evaluate();
  }

  @Override
  public String toString() {
    return String.format("- (%s)", super.arg);
  }
}
