package de.unisaar.jfap.ex6.calculator;

import static org.assertj.core.api.Assertions.assertThat;

import java.io.IOException;
import java.text.ParseException;
import org.junit.jupiter.api.Test;

class CalculatorTest {

  @Test
  void testCalculator() throws ParseException, IOException {
    assertThat(Calculator.parseAndEvaluate("7 * (3 * - 3) - 8 * (7.5 + 6)")).isEqualTo(-171);
    assertThat(Calculator.parseAndEvaluate("((7.0 * (3.0 * - (3.0))) - (8.0 * (7.5 + 6.0)))"))
        .isEqualTo(-171);
  }
}
