package de.unisaar.jfap.ex6.operator;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

class OperatorTest {

  @Test
  void testOperator() {

    Operator op =
        new Subtract(
            new Multiply(
                new Constant("7"),
                new Multiply(new Constant("3"), new UnaryMinus(new Constant("3")))),
            new Multiply(new Constant("8"), new Add(new Constant("7.5"), new Constant("6"))));
    assertThat(op.toString()).isEqualTo("((7.0 * (3.0 * - (3.0))) - (8.0 * (7.5 + 6.0)))");
    assertThat(op.evaluate()).isEqualTo(-171);
  }
}
