package de.unisaar.jfap.ex6.monitor;

/**
 * Standard observer interface.
 *
 * @author Jörg Steffen, DFKI
 */
public interface Observer {

  /**
   * Update observer about changes in the given product.
   *
   * @param product the product
   */
  void update(Product product);
}
