package de.unisaar.jfap.ex6.operator;

/**
 * Binary operator for summation.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public class Add extends BinaryOperator {

  public Add(Operator left, Operator right) {
    super(left, right);
  }

  @Override
  public double evaluate() {
    return super.left.evaluate() + super.right.evaluate();
  }

  @Override
  public String toString() {
    return super.toString('+');
  }
}
