package de.unisaar.jfap.ex6.operator;

/**
 * Binary operator for multiplication.
 *
 * @author Bernd Kiefer, DFKI
 * @author Jörg Steffen, DFKI
 */
public class Multiply extends BinaryOperator {

  public Multiply(Operator left, Operator right) {
    super(left, right);
  }

  @Override
  public double evaluate() {
    return super.left.evaluate() * super.right.evaluate();
  }

  @Override
  public String toString() {
    return super.toString('*');
  }
}
